\ProvidesPackage{lstrtfiacre}
\RequirePackage{listings}
\RequirePackage{tabularx}

\lstdefinestyle{trans}{
	aboveskip=-\medskipamount,
	belowskip=-\medskipamount
}

\lstdefinelanguage{fiacre}%
	{keywords={
		function, begin, return, 
                and, any, append, array, bool, case, channel, component, const, dequeue,
		do, else, elsif, empty, end, enqueue, false, first, foreach, from, full, 
		if, in, int, init, is, loop, nat, none, null, of, on, or, out, par,
		port,
		priority, process, queue, read, record, self, states, then, to, true,
		type, union, unless, var, wait, where, while, write,
                default, select, 
                assert,property, leadsto, enter, exit, within, value,
                ltl, true, false, until,event,value,tag,and,or,not
	}, sensitive=true,comment=[s]{/*}{*/},
	basicstyle=\footnotesize,
	keywordstyle=\color{blue},
	commentstyle=\color{gray}}

\lstdefinelanguage{rtfiacre}[]{fiacre}%
	{morekeywords={
		all, constr0, constr1, exists, SORTED_WAIT, WAIT
	},
        morestring=[b]",
        showstringspaces=false,
        stringstyle=\ttfamily}

\lstnewenvironment{fiacre}{\lstset{language=fiacre}}{}
\lstnewenvironment{rtfiacre}{\lstset{language=rtfiacre}}{}

\newcommand{\trans}[2]{%
	\renewcommand{\tablename}{\textsc{Listing}}
	\begin{table}[htb!]
		\begin{tabularx}{\textwidth}{X|X}
			\lstinputlisting[style=trans,language=rtfiacre]
			{code/#1.rtfcr}
			&
			\lstinputlisting[style=trans,language=fiacre]
			{code/#1.fcr}
		\end{tabularx}
		\caption{#2}
		\label{lst:#1}
	\end{table}
}
